Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing.event
Class EventListenerList

    java.lang.Object
      |
      +--javax.swing.event.EventListenerList

public class EventListenerList
extends java.lang.Object
implements java.io.Serializable

A class which holds a list of EventListeners. A single instance can be used to hold all listeners (of all types) for the instance using the lsit. It is the responsiblity of the class using the EventListenerList to provide type-safe API (preferably conforming to the JavaBeans spec) and methods which dispatch event notification methods to appropriate Event Listeners on the list. The main benefits which this class provides are that it is relatively cheap in the case of no listeners, and provides serialization for eventlistener lists in a single place, as well as a degree of MT safety (when used correctly). Usage example: Say one is defining a class which sends out FooEvents, and wantds to allow users of the class to register FooListeners and receive notification when FooEvents occur. The following should be added to the class definition:

    EventListenerList listenrList = new EventListnerList();
    FooEvent fooEvent = null;

    public void addFooListener(FooListener l) {
    listenerList.add(FooListener.class, l);
    }

    public void removeFooListener(FooListener l) {
    listenerList.remove(FooListener.class, l);
    }

    // Notify all listeners that have registered interest for
    // notification on this event type.  The event instance
    // is lazily created using the parameters passed into
    // the fire method.

    protected void firefooXXX() {
    // Guaranteed to return a non-null array
    Object[] listeners = listenerList.getListenerList();
    // Process the listeners last to first, notifying
    // those that are interested in this event
    for (int i = listeners.length-2; i>=0; i-=2) {
    if (listeners[i]==FooListener.class) {
    // Lazily create the event:
    if (fooEvent == null)
    fooEvent = new FooEvent(this);
    ((FooListener)listeners[i+1]).fooXXX(fooEvent);
    }
    }
    }

foo should be changed to the appropriate name, and Method to the appropriate method name (one fire method should exist for each notification method in the FooListener interface).

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. A future release of Swing will provide support for long term persistence.

See Also:
  Serialized Form

Field Summary
`protected java.lang.Object[]` | `listenerList`

Constructor Summary
`EventListenerList()`

Method Summary
`void` | `add(java.lang.Class t, java.util.EventListener l)` Add the listener as a listener of the specified type.
`int` | `getListenerCount()` Return the total number of listeners for this listenerlist
`int` | `getListenerCount(java.lang.Class t)` Return the total number of listeners of the supplied type for this listenerlist.
`java.lang.Object[]` | `getListenerList()` This passes back the event listener list as an array of ListenerType - listener pairs.
`void` | `remove(java.lang.Class t, java.util.EventListener l)` Remove the listener as a listener of the specified type.
`java.lang.String` | `toString()` Return a string representation of the EventListenerList.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### listenerList

    protected transient java.lang.Object[] listenerList

Constructor Detail

### EventListenerList

    public EventListenerList()

Method Detail

### getListenerList

    public java.lang.Object[] getListenerList()

  This passes back the event listener list as an array of ListenerType - listener pairs. Note that for performance reasons, this implementation passes back the actual data structure in which the listner data is stored internally! This method is guaranteed to pass back a non-null array, so that no null-checking is required in fire methods. A zero-length array of Object should be returned if there are currently no listeners. WARNING!!! Absolutely NO modification of the data contained in this array should be made -- if any such manipulation is necessary, it should be done on a copy of the array returned rather than the array itself.

### getListenerCount

    public int getListenerCount()

  Return the total number of listeners for this listenerlist

### getListenerCount

    public int getListenerCount(java.lang.Class t)

  Return the total number of listeners of the supplied type for this listenerlist.

### add

    public void add(java.lang.Class t,
                    java.util.EventListener l)

  Add the listener as a listener of the specified type.
  Parameters:
    `t` - the type of the listener to be added
    `l` - the listener to be added

### remove

    public void remove(java.lang.Class t,
                       java.util.EventListener l)

  Remove the listener as a listener of the specified type.
  Parameters:
    `t` - the type of the listener to be removed
    `l` - the listener to be removed

### toString

    public java.lang.String toString()

  Return a string representation of the EventListenerList.
  Overrides:
    toString in class java.lang.Object

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.